-- This is just a demonstrative effect
local circles = {}
local nCircles = 20
local circleRadius = 80


function love.draw()

  -- Here's the gist
  if love.window.getFullscreen() then
    local diffX = love.graphics.getWidth() - 1280
    local diffY = love.graphics.getHeight() - 720
    love.graphics.setScissor(diffX / 2, diffY / 2, 1280, 720)
    love.graphics.translate(diffX / 2, diffY / 2)
  else
    love.graphics.setScissor()
  end

  -- Now draw something for demonstrative purposes
  for i = 1, nCircles do
    love.graphics.setColor(circles[i][5], circles[i][6], circles[i][7])
    love.graphics.circle("fill", circles[i][1], circles[i][2], circleRadius)
  end

end


function love.load()
  love.window.setMode(1280, 720)
  for i = 1, nCircles do
    local direction = math.pi * 2 * love.math.random()
    local speed = love.math.random() * 200 + 50
    local vx = math.cos(direction) * speed
    local vy = math.sin(direction) * speed
    local hue = love.math.random() * 6
    local hue = love.math.random() * 6
    local r = math.min(math.max(math.abs(hue - 3) - 1, 0), 1)
    hue = (hue + 2) % 6
    local g = math.min(math.max(math.abs(hue - 3) - 1, 0), 1)
    hue = (hue + 2) % 6
    local b = math.min(math.max(math.abs(hue - 3) - 1, 0), 1)

    circles[i] = {love.math.random(1, 1280) - 1,
                  love.math.random(1, 720) - 1,
                  vx, vy, r, g, b}
  end
end


function love.update(dt)
  for i = 1, nCircles do
    local circle = circles[i]
    local saveX = circle[1]
    local saveY = circle[2]
    circle[1] = saveX + circle[3] * dt
    circle[2] = saveY + circle[4] * dt
    if circle[1] >= 1280 or circle[1] < 0 then
      circle[3] = -circle[3]
      circle[1] = saveX
    end
    if circle[2] >= 720 or circle[2] < 0 then
      circle[4] = -circle[4]
      circle[2] = saveY
    end
  end
end


function love.keyreleased(k)
  if k == "f11" and not ignoreNextKey then
    if love.window.getFullscreen() then
      love.window.setMode(1280, 720)
    else
      love.window.setFullscreen(true)
    end
  end
  return k == "escape" and love.event.quit()
end
